﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Diagnostics;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        [DllImport("TestNativeAPI.dll")]
        public static extern void fnStructTest(IntPtr cap);

        [DllImport("TestNativeAPI.dll")]
        unsafe public static extern void fnStructTest(DX_CAP *cap);

        public Form1()
        {
            InitializeComponent();

            DX_CAP inst;

            unsafe 
            { 
                fnStructTest(null);
                fnStructTest(&inst);
            }

            fnStructTest(IntPtr.Zero);

            DXC_CAP inst2 = new DXC_CAP();
            int marshalSize = 0;

            unsafe 
            {
                marshalSize = sizeof(DX_CAP);
            }

            IntPtr ptrData = Marshal.AllocCoTaskMem(marshalSize);

            Marshal.StructureToPtr(inst2, ptrData, false);
            fnStructTest(ptrData);

            Marshal.PtrToStructure(ptrData, inst2);
            Marshal.FreeCoTaskMem(ptrData);
        }

        private void button1_Click(object sender, EventArgs e)
        {
        }
    }

    public struct DX_CAP 
    {
        public ushort ca_nbrdna; 
        public ushort ca_stdely; 
        public ushort ca_cnosig; 
    };

    [StructLayout(LayoutKind.Sequential)]
    public class DXC_CAP
    {
        public ushort ca_nbrdna;
        public ushort ca_stdely;
        public ushort ca_cnosig;
    };
}
